diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -377,460 +381,714 @@ def _get_on_crash(dom):
     .. code-block:: bash
 
         salt '*' virt.get_on_crash <domain>
-    '''
-    node = ElementTree.fromstring(get_xml(dom)).find('on_crash')
-    return node.text if node is not None else ''
+    """
+    node = ElementTree.fromstring(get_xml(dom)).find("on_crash")
+    return node.text if node is not None else ""
 
 
 def _get_nics(dom):
-    '''
+    """
     Get domain network interfaces from a libvirt domain object.
-    '''
+    """
     nics = {}
     doc = ElementTree.fromstring(dom.XMLDesc(0))
-    for iface_node in doc.findall('devices/interface'):
+    for iface_node in doc.findall("devices/interface"):
         nic = {}
-        nic['type'] = iface_node.get('type')
+        nic["type"] = iface_node.get("type")
         for v_node in iface_node:
-            if v_node.tag == 'mac':
-                nic['mac'] = v_node.get('address')
-            if v_node.tag == 'model':
-                nic['model'] = v_node.get('type')
-            if v_node.tag == 'target':
-                nic['target'] = v_node.get('dev')
+            if v_node.tag == "mac":
+                nic["mac"] = v_node.get("address")
+            if v_node.tag == "model":
+                nic["model"] = v_node.get("type")
+            if v_node.tag == "target":
+                nic["target"] = v_node.get("dev")
             # driver, source, and match can all have optional attributes
-            if re.match('(driver|source|address)', v_node.tag):
+            if re.match("(driver|source|address)", v_node.tag):
                 temp = {}
                 for key, value in six.iteritems(v_node.attrib):
                     temp[key] = value
                 nic[v_node.tag] = temp
             # virtualport needs to be handled separately, to pick up the
             # type attribute of the virtualport itself
-            if v_node.tag == 'virtualport':
+            if v_node.tag == "virtualport":
                 temp = {}
-                temp['type'] = v_node.get('type')
+                temp["type"] = v_node.get("type")
                 for key, value in six.iteritems(v_node.attrib):
                     temp[key] = value
-                nic['virtualport'] = temp
-        if 'mac' not in nic:
+                nic["virtualport"] = temp
+        if "mac" not in nic:
             continue
-        nics[nic['mac']] = nic
+        nics[nic["mac"]] = nic
     return nics
 
 
 def _get_graphics(dom):
-    '''
+    """
     Get domain graphics from a libvirt domain object.
-    '''
-    out = {'autoport': 'None',
-           'keymap': 'None',
-           'listen': 'None',
-           'port': 'None',
-           'type': 'None'}
+    """
+    out = {
+        "autoport": "None",
+        "keymap": "None",
+        "listen": "None",
+        "port": "None",
+        "type": "None",
+    }
     doc = ElementTree.fromstring(dom.XMLDesc(0))
-    for g_node in doc.findall('devices/graphics'):
+    for g_node in doc.findall("devices/graphics"):
         for key, value in six.iteritems(g_node.attrib):
             out[key] = value
     return out
 
 
-def _get_disks(dom):
-    '''
+def _get_loader(dom):
+    """
+    Get domain loader from a libvirt domain object.
+    """
+    out = {"path": "None"}
+    doc = ElementTree.fromstring(dom.XMLDesc(0))
+    for g_node in doc.findall("os/loader"):
+        out["path"] = g_node.text
+        for key, value in six.iteritems(g_node.attrib):
+            out[key] = value
+    return out
+
+
+def _get_disks(conn, dom):
+    """
     Get domain disks from a libvirt domain object.
-    '''
+    """
     disks = {}
     doc = ElementTree.fromstring(dom.XMLDesc(0))
-    for elem in doc.findall('devices/disk'):
-        source = elem.find('source')
+    for elem in doc.findall("devices/disk"):
+        source = elem.find("source")
         if source is None:
             continue
-        target = elem.find('target')
+        target = elem.find("target")
+        driver = elem.find("driver")
         if target is None:
             continue
-        if 'dev' in target.attrib:
-            qemu_target = source.get('file', '')
-            if not qemu_target:
-                qemu_target = source.get('dev', '')
-            if not qemu_target and 'protocol' in source.attrib and 'name' in source.attrib:  # for rbd network
-                qemu_target = '{0}:{1}'.format(
-                        source.get('protocol'),
-                        source.get('name'))
+        qemu_target = None
+        extra_properties = None
+        if "dev" in target.attrib:
+            disk_type = elem.get("type")
+            if disk_type == "file":
+                qemu_target = source.get("file", "")
+                if qemu_target.startswith("/dev/zvol/"):
+                    disks[target.get("dev")] = {"file": qemu_target, "zfs": True}
+                    continue
+                # Extract disk sizes, snapshots, backing files
+                if elem.get("device", "disk") != "cdrom":
+                    try:
+                        stdout = subprocess.Popen(
+                            [
+                                "qemu-img",
+                                "info",
+                                "-U",
+                                "--output",
+                                "json",
+                                "--backing-chain",
+                                qemu_target,
+                            ],
+                            shell=False,
+                            stdout=subprocess.PIPE,
+                        ).communicate()[0]
+                        qemu_output = salt.utils.stringutils.to_str(stdout)
+                        output = _parse_qemu_img_info(qemu_output)
+                        extra_properties = output
+                    except TypeError:
+                        disk.update({"file": "Does not exist"})
+            elif disk_type == "block":
+                qemu_target = source.get("dev", "")
+            elif disk_type == "network":
+                qemu_target = source.get("protocol")
+                source_name = source.get("name")
+                if source_name:
+                    qemu_target = "{0}:{1}".format(qemu_target, source_name)
+
+                # Reverse the magic for the rbd and gluster pools
+                if source.get("protocol") in ["rbd", "gluster"]:
+                    for pool_i in conn.listAllStoragePools():
+                        pool_i_xml = ElementTree.fromstring(pool_i.XMLDesc())
+                        name_node = pool_i_xml.find("source/name")
+                        if name_node is not None and source_name.startswith(
+                            "{}/".format(name_node.text)
+                        ):
+                            qemu_target = "{}{}".format(
+                                pool_i.name(), source_name[len(name_node.text) :]
+                            )
+                            break
+
+                # Reverse the magic for cdroms with remote URLs
+                if elem.get("device", "disk") == "cdrom":
+                    host_node = source.find("host")
+                    if host_node is not None:
+                        hostname = host_node.get("name")
+                        port = host_node.get("port")
+                        qemu_target = urlunparse(
+                            (
+                                source.get("protocol"),
+                                "{}:{}".format(hostname, port) if port else hostname,
+                                source_name,
+                                "",
+                                saxutils.unescape(source.get("query", "")),
+                                "",
+                            )
+                        )
+            elif disk_type == "volume":
+                pool_name = source.get("pool")
+                volume_name = source.get("volume")
+                qemu_target = "{}/{}".format(pool_name, volume_name)
+                pool = conn.storagePoolLookupByName(pool_name)
+                vol = pool.storageVolLookupByName(volume_name)
+                vol_info = vol.info()
+                extra_properties = {
+                    "virtual size": vol_info[1],
+                    "disk size": vol_info[2],
+                }
+
+                backing_files = [
+                    {
+                        "file": node.find("source").get("file"),
+                        "file format": node.find("format").get("type"),
+                    }
+                    for node in elem.findall(".//backingStore[source]")
+                ]
+
+                if backing_files:
+                    # We had the backing files in a flat list, nest them again.
+                    extra_properties["backing file"] = backing_files[0]
+                    parent = extra_properties["backing file"]
+                    for sub_backing_file in backing_files[1:]:
+                        parent["backing file"] = sub_backing_file
+                        parent = sub_backing_file
+
+                else:
+                    # In some cases the backing chain is not displayed by the domain definition
+                    # Try to see if we have some of it in the volume definition.
+                    vol_desc = ElementTree.fromstring(vol.XMLDesc())
+                    backing_path = vol_desc.find("./backingStore/path")
+                    backing_format = vol_desc.find("./backingStore/format")
+                    if backing_path is not None:
+                        extra_properties["backing file"] = {"file": backing_path.text}
+                        if backing_format is not None:
+                            extra_properties["backing file"][
+                                "file format"
+                            ] = backing_format.get("type")
+
             if not qemu_target:
                 continue
 
-            disk = {'file': qemu_target, 'type': elem.get('device')}
-
-            driver = elem.find('driver')
-            if driver is not None and driver.get('type') == 'qcow2':
-                try:
-                    stdout = subprocess.Popen(
-                                ['qemu-img', 'info', '-U', '--output', 'json', '--backing-chain', disk['file']],
-                                shell=False,
-                                stdout=subprocess.PIPE).communicate()[0]
-                    qemu_output = salt.utils.stringutils.to_str(stdout)
-                    output = _parse_qemu_img_info(qemu_output)
-                    disk.update(output)
-                except TypeError:
-                    disk.update({'file': 'Does not exist'})
-
-            disks[target.get('dev')] = disk
+            disk = {
+                "file": qemu_target,
+                "type": elem.get("device"),
+            }
+            if driver is not None and "type" in driver.attrib:
+                disk["file format"] = driver.get("type")
+            if extra_properties:
+                disk.update(extra_properties)
+
+            disks[target.get("dev")] = disk
     return disks
 
 
 def _libvirt_creds():
-    '''
+    """
     Returns the user and group that the disk images should be owned by
-    '''
-    g_cmd = 'grep ^\\s*group /etc/libvirt/qemu.conf'
-    u_cmd = 'grep ^\\s*user /etc/libvirt/qemu.conf'
+    """
+    g_cmd = "grep ^\\s*group /etc/libvirt/qemu.conf"
+    u_cmd = "grep ^\\s*user /etc/libvirt/qemu.conf"
     try:
-        stdout = subprocess.Popen(g_cmd,
-                                  shell=True,
-                                  stdout=subprocess.PIPE).communicate()[0]
+        stdout = subprocess.Popen(
+            g_cmd, shell=True, stdout=subprocess.PIPE
+        ).communicate()[0]
         group = salt.utils.stringutils.to_str(stdout).split('"')[1]
     except IndexError:
-        group = 'root'
+        group = "root"
     try:
-        stdout = subprocess.Popen(u_cmd,
-                                  shell=True,
-                                  stdout=subprocess.PIPE).communicate()[0]
+        stdout = subprocess.Popen(
+            u_cmd, shell=True, stdout=subprocess.PIPE
+        ).communicate()[0]
         user = salt.utils.stringutils.to_str(stdout).split('"')[1]
     except IndexError:
-        user = 'root'
-    return {'user': user, 'group': group}
+        user = "root"
+    return {"user": user, "group": group}
 
 
 def _get_migrate_command():
-    '''
+    """
     Returns the command shared by the different migration types
-    '''
-    tunnel = __salt__['config.option']('virt.tunnel')
-    if tunnel:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'virt.tunnel\' has been deprecated in favor of '
-            '\'virt:tunnel\'. \'virt.tunnel\' will stop '
-            'being used in {version}.')
-    else:
-        tunnel = __salt__['config.get']('virt:tunnel')
+    """
+    tunnel = __salt__["config.get"]("virt:tunnel")
     if tunnel:
-        return ('virsh migrate --p2p --tunnelled --live --persistent '
-                '--undefinesource ')
-    return 'virsh migrate --live --persistent --undefinesource '
+        return (
+            "virsh migrate --p2p --tunnelled --live --persistent " "--undefinesource "
+        )
+    return "virsh migrate --live --persistent --undefinesource "
 
 
 def _get_target(target, ssh):
-    '''
+    """
     Compute libvirt URL for target migration host.
-    '''
-    proto = 'qemu'
+    """
+    proto = "qemu"
     if ssh:
-        proto += '+ssh'
-    return ' {0}://{1}/{2}'.format(proto, target, 'system')
-
-
-def _gen_xml(name,
-             cpu,
-             mem,
-             diskp,
-             nicp,
-             hypervisor,
-             os_type,
-             arch,
-             graphics=None,
-             boot=None,
-             **kwargs):
-    '''
+        proto += "+ssh"
+    return " {0}://{1}/{2}".format(proto, target, "system")
+
+
+def _gen_xml(
+    conn,
+    name,
+    cpu,
+    mem,
+    diskp,
+    nicp,
+    hypervisor,
+    os_type,
+    arch,
+    graphics=None,
+    boot=None,
+    **kwargs
+):
+    """
     Generate the XML string to define a libvirt VM
-    '''
+    """
     mem = int(mem) * 1024  # MB
     context = {
-        'hypervisor': hypervisor,
-        'name': name,
-        'cpu': six.text_type(cpu),
-        'mem': six.text_type(mem),
+        "hypervisor": hypervisor,
+        "name": name,
+        "cpu": six.text_type(cpu),
+        "mem": six.text_type(mem),
     }
-    if hypervisor in ['qemu', 'kvm']:
-        context['controller_model'] = False
-    elif hypervisor == 'vmware':
+    if hypervisor in ["qemu", "kvm"]:
+        context["controller_model"] = False
+    elif hypervisor == "vmware":
         # TODO: make bus and model parameterized, this works for 64-bit Linux
-        context['controller_model'] = 'lsilogic'
+        context["controller_model"] = "lsilogic"
 
     # By default, set the graphics to listen to all addresses
     if graphics:
-        if 'listen' not in graphics:
-            graphics['listen'] = {'type': 'address', 'address': '0.0.0.0'}
-        elif 'address' not in graphics['listen'] and graphics['listen']['type'] == 'address':
-            graphics['listen']['address'] = '0.0.0.0'
+        if "listen" not in graphics:
+            graphics["listen"] = {"type": "address", "address": "0.0.0.0"}
+        elif (
+            "address" not in graphics["listen"]
+            and graphics["listen"]["type"] == "address"
+        ):
+            graphics["listen"]["address"] = "0.0.0.0"
 
         # Graphics of type 'none' means no graphics device at all
-        if graphics.get('type', 'none') == 'none':
+        if graphics.get("type", "none") == "none":
             graphics = None
-    context['graphics'] = graphics
+    context["graphics"] = graphics
 
-    if 'boot_dev' in kwargs:
-        context['boot_dev'] = []
-        for dev in kwargs['boot_dev'].split():
-            context['boot_dev'].append(dev)
+    if "boot_dev" in kwargs:
+        context["boot_dev"] = []
+        for dev in kwargs["boot_dev"].split():
+            context["boot_dev"].append(dev)
     else:
-        context['boot_dev'] = ['hd']
+        context["boot_dev"] = ["hd"]
 
-    context['boot'] = boot if boot else {}
+    context["boot"] = boot if boot else {}
 
-    if os_type == 'xen':
+    if os_type == "xen":
         # Compute the Xen PV boot method
-        if __grains__['os_family'] == 'Suse':
-            if not boot or not boot.get('kernel', None):
-                context['boot']['kernel'] = \
-                        '/usr/lib/grub2/x86_64-xen/grub.xen'
-                context['boot_dev'] = []
-
-    if 'serial_type' in kwargs:
-        context['serial_type'] = kwargs['serial_type']
-    if 'serial_type' in context and context['serial_type'] == 'tcp':
-        if 'telnet_port' in kwargs:
-            context['telnet_port'] = kwargs['telnet_port']
+        if __grains__["os_family"] == "Suse":
+            if not boot or not boot.get("kernel", None):
+                context["boot"]["kernel"] = "/usr/lib/grub2/x86_64-xen/grub.xen"
+                context["boot_dev"] = []
+
+    if "serial_type" in kwargs:
+        context["serial_type"] = kwargs["serial_type"]
+    if "serial_type" in context and context["serial_type"] == "tcp":
+        if "telnet_port" in kwargs:
+            context["telnet_port"] = kwargs["telnet_port"]
         else:
-            context['telnet_port'] = 23023  # FIXME: use random unused port
-    if 'serial_type' in context:
-        if 'console' in kwargs:
-            context['console'] = kwargs['console']
+            context["telnet_port"] = 23023  # FIXME: use random unused port
+    if "serial_type" in context:
+        if "console" in kwargs:
+            context["console"] = kwargs["console"]
         else:
-            context['console'] = True
+            context["console"] = True
 
-    context['disks'] = []
-    disk_bus_map = {'virtio': 'vd', 'xen': 'xvd', 'fdc': 'fd', 'ide': 'hd'}
+    context["disks"] = []
+    disk_bus_map = {"virtio": "vd", "xen": "xvd", "fdc": "fd", "ide": "hd"}
+    targets = []
     for i, disk in enumerate(diskp):
-        prefix = disk_bus_map.get(disk['model'], 'sd')
+        prefix = disk_bus_map.get(disk["model"], "sd")
         disk_context = {
-            'device': disk.get('device', 'disk'),
-            'target_dev': '{0}{1}'.format(prefix, string.ascii_lowercase[i]),
-            'disk_bus': disk['model'],
-            'type': disk['format'],
-            'index': six.text_type(i),
+            "device": disk.get("device", "disk"),
+            "target_dev": _get_disk_target(targets, len(diskp), prefix),
+            "disk_bus": disk["model"],
+            "format": disk.get("format", "raw"),
+            "index": six.text_type(i),
         }
-        if 'source_file' and disk['source_file']:
-            disk_context['source_file'] = disk['source_file']
-
-        if hypervisor in ['qemu', 'kvm', 'bhyve', 'xen']:
-            disk_context['address'] = False
-            disk_context['driver'] = True
-        elif hypervisor in ['esxi', 'vmware']:
-            disk_context['address'] = True
-            disk_context['driver'] = False
-        context['disks'].append(disk_context)
-    context['nics'] = nicp
-
-    context['os_type'] = os_type
-    context['arch'] = arch
-
-    fn_ = 'libvirt_domain.jinja'
+        targets.append(disk_context["target_dev"])
+        if disk.get("source_file"):
+            url = urlparse(disk["source_file"])
+            if not url.scheme or not url.hostname:
+                disk_context["source_file"] = disk["source_file"]
+                disk_context["type"] = "file"
+            elif url.scheme in ["http", "https", "ftp", "ftps", "tftp"]:
+                disk_context["type"] = "network"
+                disk_context["protocol"] = url.scheme
+                disk_context["volume"] = url.path
+                disk_context["query"] = saxutils.escape(url.query)
+                disk_context["hosts"] = [{"name": url.hostname, "port": url.port}]
+
+        elif disk.get("pool"):
+            disk_context["volume"] = disk["filename"]
+            # If we had no source_file, then we want a volume
+            pool_xml = ElementTree.fromstring(
+                conn.storagePoolLookupByName(disk["pool"]).XMLDesc()
+            )
+            pool_type = pool_xml.get("type")
+            if pool_type in ["rbd", "gluster", "sheepdog"]:
+                # libvirt can't handle rbd, gluster and sheepdog as volumes
+                disk_context["type"] = "network"
+                disk_context["protocol"] = pool_type
+                # Copy the hosts from the pool definition
+                disk_context["hosts"] = [
+                    {"name": host.get("name"), "port": host.get("port")}
+                    for host in pool_xml.findall(".//host")
+                ]
+                dir_node = pool_xml.find("./source/dir")
+                # Gluster and RBD need pool/volume name
+                name_node = pool_xml.find("./source/name")
+                if name_node is not None:
+                    disk_context["volume"] = "{}/{}".format(
+                        name_node.text, disk_context["volume"]
+                    )
+                # Copy the authentication if any for RBD
+                auth_node = pool_xml.find("./source/auth")
+                if auth_node is not None:
+                    username = auth_node.get("username")
+                    secret_node = auth_node.find("./secret")
+                    usage = secret_node.get("usage")
+                    if not usage:
+                        # Get the usage from the UUID
+                        uuid = secret_node.get("uuid")
+                        usage = conn.secretLookupByUUIDString(uuid).usageID()
+                    disk_context["auth"] = {
+                        "type": "ceph",
+                        "username": username,
+                        "usage": usage,
+                    }
+            else:
+                if pool_type in ["disk", "logical"]:
+                    # The volume format for these types doesn't match the driver format in the VM
+                    disk_context["format"] = "raw"
+                disk_context["type"] = "volume"
+                disk_context["pool"] = disk["pool"]
+
+        else:
+            # No source and no pool is a removable device, use file type
+            disk_context["type"] = "file"
+
+        if hypervisor in ["qemu", "kvm", "bhyve", "xen"]:
+            disk_context["address"] = False
+            disk_context["driver"] = True
+        elif hypervisor in ["esxi", "vmware"]:
+            disk_context["address"] = True
+            disk_context["driver"] = False
+        context["disks"].append(disk_context)
+    context["nics"] = nicp
+
+    context["os_type"] = os_type
+    context["arch"] = arch
+
+    fn_ = "libvirt_domain.jinja"
     try:
         template = JINJA.get_template(fn_)
     except jinja2.exceptions.TemplateNotFound:
-        log.error('Could not load template %s', fn_)
-        return ''
+        log.error("Could not load template %s", fn_)
+        return ""
 
     return template.render(**context)
 
 
-def _gen_vol_xml(vmname,
-                 diskname,
-                 disktype,
-                 size,
-                 pool):
-    '''
+def _gen_vol_xml(
+    name,
+    size,
+    format=None,
+    allocation=0,
+    type=None,
+    permissions=None,
+    backing_store=None,
+    nocow=False,
+):
+    """
     Generate the XML string to define a libvirt storage volume
-    '''
+    """
     size = int(size) * 1024  # MB
     context = {
-        'name': vmname,
-        'filename': '{0}.{1}'.format(diskname, disktype),
-        'volname': diskname,
-        'disktype': disktype,
-        'size': six.text_type(size),
-        'pool': pool,
+        "type": type,
+        "name": name,
+        "target": {"permissions": permissions, "nocow": nocow},
+        "format": format,
+        "size": six.text_type(size),
+        "allocation": six.text_type(int(allocation) * 1024),
+        "backingStore": backing_store,
     }
-    fn_ = 'libvirt_volume.jinja'
+    fn_ = "libvirt_volume.jinja"
     try:
         template = JINJA.get_template(fn_)
     except jinja2.exceptions.TemplateNotFound:
-        log.error('Could not load template %s', fn_)
-        return ''
+        log.error("Could not load template %s", fn_)
+        return ""
     return template.render(**context)
 
 
-def _gen_net_xml(name,
-                 bridge,
-                 forward,
-                 vport,
-                 tag=None,
-                 ip_configs=None):
-    '''
+def _gen_net_xml(name, bridge, forward, vport, tag=None, ip_configs=None):
+    """
     Generate the XML string to define a libvirt network
-    '''
+    """
     context = {
-        'name': name,
-        'bridge': bridge,
-        'forward': forward,
-        'vport': vport,
-        'tag': tag,
-        'ip_configs': [{
-            'address': ipaddress.ip_network(config['cidr']),
-            'dhcp_ranges': config.get('dhcp_ranges', []),
-        } for config in ip_configs or []],
+        "name": name,
+        "bridge": bridge,
+        "forward": forward,
+        "vport": vport,
+        "tag": tag,
+        "ip_configs": [
+            {
+                "address": ipaddress.ip_network(config["cidr"]),
+                "dhcp_ranges": config.get("dhcp_ranges", []),
+            }
+            for config in ip_configs or []
+        ],
     }
-    fn_ = 'libvirt_network.jinja'
+    fn_ = "libvirt_network.jinja"
     try:
         template = JINJA.get_template(fn_)
     except jinja2.exceptions.TemplateNotFound:
-        log.error('Could not load template %s', fn_)
-        return ''
+        log.error("Could not load template %s", fn_)
+        return ""
     return template.render(**context)
 
 
-def _gen_pool_xml(name,
-                  ptype,
-                  target=None,
-                  permissions=None,
-                  source_devices=None,
-                  source_dir=None,
-                  source_adapter=None,
-                  source_hosts=None,
-                  source_auth=None,
-                  source_name=None,
-                  source_format=None,
-                  source_initiator=None):
-    '''
+def _gen_pool_xml(
+    name,
+    ptype,
+    target=None,
+    permissions=None,
+    source_devices=None,
+    source_dir=None,
+    source_adapter=None,
+    source_hosts=None,
+    source_auth=None,
+    source_name=None,
+    source_format=None,
+    source_initiator=None,
+):
+    """
     Generate the XML string to define a libvirt storage pool
-    '''
-    hosts = [host.split(':') for host in source_hosts or []]
+    """
+    hosts = [host.split(":") for host in source_hosts or []]
     source = None
-    if any([source_devices, source_dir, source_adapter, hosts, source_auth, source_name, source_format,
-            source_initiator]):
+    if any(
+        [
+            source_devices,
+            source_dir,
+            source_adapter,
+            hosts,
+            source_auth,
+            source_name,
+            source_format,
+            source_initiator,
+        ]
+    ):
         source = {
-            'devices': source_devices or [],
-            'dir': source_dir if source_format != 'cifs' or not source_dir else source_dir.lstrip('/'),
-            'adapter': source_adapter,
-            'hosts': [{'name': host[0], 'port': host[1] if len(host) > 1 else None} for host in hosts],
-            'auth': source_auth,
-            'name': source_name,
-            'format': source_format,
-            'initiator': source_initiator,
+            "devices": source_devices or [],
+            "dir": source_dir
+            if source_format != "cifs" or not source_dir
+            else source_dir.lstrip("/"),
+            "adapter": source_adapter,
+            "hosts": [
+                {"name": host[0], "port": host[1] if len(host) > 1 else None}
+                for host in hosts
+            ],
+            "auth": source_auth,
+            "name": source_name,
+            "format": source_format,
+            "initiator": source_initiator,
         }
 
     context = {
-        'name': name,
-        'ptype': ptype,
-        'target': {'path': target, 'permissions': permissions},
-        'source': source
+        "name": name,
+        "ptype": ptype,
+        "target": {"path": target, "permissions": permissions},
+        "source": source,
     }
-    fn_ = 'libvirt_pool.jinja'
+    fn_ = "libvirt_pool.jinja"
     try:
         template = JINJA.get_template(fn_)
     except jinja2.exceptions.TemplateNotFound:
-        log.error('Could not load template %s', fn_)
-        return ''
+        log.error("Could not load template %s", fn_)
+        return ""
     return template.render(**context)
 
 
 def _gen_secret_xml(auth_type, usage, description):
-    '''
+    """
     Generate a libvirt secret definition XML
-    '''
+    """
     context = {
-        'type': auth_type,
-        'usage': usage,
-        'description': description,
+        "type": auth_type,
+        "usage": usage,
+        "description": description,
     }
-    fn_ = 'libvirt_secret.jinja'
+    fn_ = "libvirt_secret.jinja"
     try:
         template = JINJA.get_template(fn_)
     except jinja2.exceptions.TemplateNotFound:
-        log.error('Could not load template %s', fn_)
-        return ''
+        log.error("Could not load template %s", fn_)
+        return ""
     return template.render(**context)
 
 
 def _get_images_dir():
-    '''
+    """
     Extract the images dir from the configuration. First attempts to
     find legacy virt.images, then tries virt:images.
-    '''
-    img_dir = __salt__['config.option']('virt.images')
-    if img_dir:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'virt.images\' has been deprecated in favor of '
-            '\'virt:images\'. \'virt.images\' will stop '
-            'being used in {version}.')
-    else:
-        img_dir = __salt__['config.get']('virt:images')
-
-    log.debug('Image directory from config option `virt:images`'
-              ' is %s', img_dir)
+    """
+    img_dir = __salt__["config.get"]("virt:images")
+    log.debug("Image directory from config option `virt:images`" " is %s", img_dir)
     return img_dir
 
 
-def _qemu_image_create(disk, create_overlay=False, saltenv='base'):
-    '''
+def _zfs_image_create(
+    vm_name,
+    pool,
+    disk_name,
+    hostname_property_name,
+    sparse_volume,
+    disk_size,
+    disk_image_name,
+):
+    """
+    Clones an existing image, or creates a new one.
+
+    When cloning an image, disk_image_name refers to the source
+    of the clone. If not specified, disk_size is used for creating
+    a new zvol, and sparse_volume determines whether to create
+    a thin provisioned volume.
+
+    The cloned or new volume can have a ZFS property set containing
+    the vm_name. Use hostname_property_name for specifying the key
+    of this ZFS property.
+    """
+    if not disk_image_name and not disk_size:
+        raise CommandExecutionError(
+            "Unable to create new disk {0}, please specify"
+            " the disk image name or disk size argument".format(disk_name)
+        )
+
+    if not pool:
+        raise CommandExecutionError(
+            "Unable to create new disk {0}, please specify"
+            " the disk pool name".format(disk_name)
+        )
+
+    destination_fs = os.path.join(pool, "{0}.{1}".format(vm_name, disk_name))
+    log.debug("Image destination will be %s", destination_fs)
+
+    existing_disk = __salt__["zfs.list"](name=pool)
+    if "error" in existing_disk:
+        raise CommandExecutionError(
+            "Unable to create new disk {0}. {1}".format(
+                destination_fs, existing_disk["error"]
+            )
+        )
+    elif destination_fs in existing_disk:
+        log.info(
+            "ZFS filesystem {0} already exists. Skipping creation".format(
+                destination_fs
+            )
+        )
+        blockdevice_path = os.path.join("/dev/zvol", pool, vm_name)
+        return blockdevice_path
+
+    properties = {}
+    if hostname_property_name:
+        properties[hostname_property_name] = vm_name
+
+    if disk_image_name:
+        __salt__["zfs.clone"](
+            name_a=disk_image_name, name_b=destination_fs, properties=properties
+        )
+
+    elif disk_size:
+        __salt__["zfs.create"](
+            name=destination_fs,
+            properties=properties,
+            volume_size=disk_size,
+            sparse=sparse_volume,
+        )
+
+    blockdevice_path = os.path.join(
+        "/dev/zvol", pool, "{0}.{1}".format(vm_name, disk_name)
+    )
+    log.debug("Image path will be %s", blockdevice_path)
+    return blockdevice_path
+
+
+def _qemu_image_create(disk, create_overlay=False, saltenv="base"):
+    """
     Create the image file using specified disk_size or/and disk_image
 
     Return path to the created image file
-    '''
-    disk_size = disk.get('size', None)
-    disk_image = disk.get('image', None)
+    """
+    disk_size = disk.get("size", None)
+    disk_image = disk.get("image", None)
 
     if not disk_size and not disk_image:
         raise CommandExecutionError(
-            'Unable to create new disk {0}, please specify'
-            ' disk size and/or disk image argument'
-            .format(disk['filename'])
+            "Unable to create new disk {0}, please specify"
+            " disk size and/or disk image argument".format(disk["filename"])
         )
 
-    img_dest = disk['source_file']
-    log.debug('Image destination will be %s', img_dest)
+    img_dest = disk["source_file"]
+    log.debug("Image destination will be %s", img_dest)
     img_dir = os.path.dirname(img_dest)
-    log.debug('Image destination directory is %s', img_dir)
+    log.debug("Image destination directory is %s", img_dir)
     if not os.path.exists(img_dir):
         os.makedirs(img_dir)
 
     if disk_image:
-        log.debug('Create disk from specified image %s', disk_image)
-        sfn = __salt__['cp.cache_file'](disk_image, saltenv)
+        log.debug("Create disk from specified image %s", disk_image)
+        sfn = __salt__["cp.cache_file"](disk_image, saltenv)
 
         qcow2 = False
-        if salt.utils.path.which('qemu-img'):
-            res = __salt__['cmd.run']('qemu-img info "{}"'.format(sfn))
+        if salt.utils.path.which("qemu-img"):
+            res = __salt__["cmd.run"]('qemu-img info "{}"'.format(sfn))
             imageinfo = salt.utils.yaml.safe_load(res)
-            qcow2 = imageinfo['file format'] == 'qcow2'
+            qcow2 = imageinfo["file format"] == "qcow2"
         try:
             if create_overlay and qcow2:
-                log.info('Cloning qcow2 image %s using copy on write', sfn)
-                __salt__['cmd.run'](
-                    'qemu-img create -f qcow2 -o backing_file="{0}" "{1}"'
-                    .format(sfn, img_dest).split())
+                log.info("Cloning qcow2 image %s using copy on write", sfn)
+                __salt__["cmd.run"](
+                    'qemu-img create -f qcow2 -o backing_file="{0}" "{1}"'.format(
+                        sfn, img_dest
+                    ).split()
+                )
             else:
-                log.debug('Copying %s to %s', sfn, img_dest)
+                log.debug("Copying %s to %s", sfn, img_dest)
                 salt.utils.files.copyfile(sfn, img_dest)
 
             mask = salt.utils.files.get_umask()
 
             if disk_size and qcow2:
-                log.debug('Resize qcow2 image to %sM', disk_size)
-                __salt__['cmd.run'](
-                    'qemu-img resize "{0}" {1}M'
-                    .format(img_dest, disk_size)
+                log.debug("Resize qcow2 image to %sM", disk_size)
+                __salt__["cmd.run"](
+                    'qemu-img resize "{0}" {1}M'.format(img_dest, disk_size)
                 )
 
-            log.debug('Apply umask and remove exec bit')
+            log.debug("Apply umask and remove exec bit")
             mode = (0o0777 ^ mask) & 0o0666
             os.chmod(img_dest, mode)
 
         except (IOError, OSError) as err:
             raise CommandExecutionError(
-                'Problem while copying image. {0} - {1}'
-                .format(disk_image, err)
+                "Problem while copying image. {0} - {1}".format(disk_image, err)
             )
 
     else:
